Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSecurityPermission.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSecurityPermission.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsSecurityPermission.cs	(revision 51)
@@ -33,6 +33,10 @@
         private static readonly ILog logger = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
         #endregion
 
+        #region 定数
+        #endregion
+
+        #region 旧セキュリティメソッド
         #region 工事データアクセス許可
         /// <summary>
         /// 工事データアクセス許可確認
@@ -362,5 +366,752 @@
             }
         }
         #endregion
+        #endregion
+
+        #region セキュリティメソッド
+
+        #region 対象セキュリティ区分のデータアクセスランク・レンジを返す
+        /// <summary>
+        /// 対象セキュリティ区分のデータアクセスランク・レンジを返す
+        /// </summary>
+        /// <param name="SecCode"></param>
+        /// <returns></returns>
+        public static int GetDataAccessRank(int SecCode, ref int Range)
+        {
+            IOMSecurity SecDB = new IOMSecurity();
+
+            // 初期値として一般ユーザーをセットする
+            int Rank = CommonDefine.SecurityRankList[(int)CommonDefine.SecurityRankPos.NormalAuthority].Key;
+            try
+            {
+                // 初期値として参照無をセットする
+                Range = CommonDefine.SecurityRangeList[(int)CommonDefine.SecurityRangePos.None].Key;
+
+                // 担当者マスタより保護区分マスタを取得する
+                string strSQL = "SELECT A.SECCODE, A.SECNAME, A.SECRANK, A.SECRANGE FROM SECURITYMASTER A";
+                strSQL += string.Format(" WHERE A.SECCODE = {0}", SecCode);
+
+                ArrayList arList = new ArrayList();
+                if (!SecDB.ExecuteReader(strSQL, ref arList)) return Rank;
+
+                if (arList.Count == 0) return Rank;
+                object[] objRec = (object[])arList[0];
+
+                // セキュリティランク取得
+                Rank = CommonMotions.cnvInt(objRec[2]);
+                Range = CommonMotions.cnvInt(objRec[3]);
+
+                return Rank;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return Rank;
+            }
+            finally
+            {
+                SecDB.close(); SecDB = null;
+            }
+        }
+        #endregion
+
+        #region ログイン者のデータアクセスランク・レンジを返す
+        /// <summary>
+        /// ログイン者のデータアクセスランク・レンジを返す
+        /// </summary>
+        /// <returns></returns>
+        public static int GetPersonDataAccessRank(ref int Range)
+        {
+            try
+            {
+                int iRet = 0;
+
+                if (CommonMotions.LoginUserProcExe.Count != 0)
+                {   // ログインデータにセキュリティデータがあればそこから取得
+                    iRet = CommonMotions.LoginUserSecurity.SecRank;
+                    Range = CommonMotions.LoginUserSecurity.SecRange;
+                }
+                else
+                {   // 無い場合はDBより取得する
+                    iRet = GetPersonDataAccessRank(CommonMotions.LoginUserData.PersonCode, ref Range);
+                }
+                return iRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return CommonDefine.SecurityRankList[(int)CommonDefine.SecurityRankPos.NormalAuthority].Key;
+            }
+        }
+        #endregion
+
+        #region 対象者のデータアクセスランク・レンジを返す
+        /// <summary>
+        /// 対象者のデータアクセスランク・レンジを返す
+        /// </summary>
+        /// <returns></returns>
+        public static int GetPersonDataAccessRank(int PersonCode, ref int Range)
+        {
+            IOMSecurity SecDB = new IOMSecurity();
+
+            // 初期値として一般ユーザーをセットする
+            int Rank = 0;
+            // 初期値として参照無をセットする
+            Range = 0;
+            try
+            {
+                if (CommonMotions.LoginUserData.SecCode == 0) return Rank;
+
+                // 初期値として一般ユーザーをセットする
+                Rank = CommonDefine.SecurityRankList[(int)CommonDefine.SecurityRankPos.NormalAuthority].Key;
+                // 初期値として参照無をセットする
+                Range = CommonDefine.SecurityRangeList[(int)CommonDefine.SecurityRangePos.None].Key;
+                
+                // 担当者マスタより保護区分マスタを取得する
+                string strSQL = "SELECT A.PERSONCODE, A.PERSONNAME, B.SECNAME, B.SECRANK, B.SECRANGE";
+                strSQL += " FROM PERSONINCHARGEMASTER A, SECURITYMASTER B";
+                strSQL += " WHERE B.SECCODE = A.SECCODE";
+                strSQL += string.Format(" AND A.PERSONCODE = {0}", PersonCode);
+
+                ArrayList arList = new ArrayList();
+                if (!SecDB.ExecuteReader(strSQL, ref arList)) return Rank;
+
+                if (arList.Count == 0) return Rank;
+                object[] objRec = (object[])arList[0];
+
+                // セキュリティランク取得
+                Rank = CommonMotions.cnvInt(objRec[3]);
+                Range = CommonMotions.cnvInt(objRec[4]);
+
+                return Rank;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return Rank;
+            }
+            finally
+            {
+                SecDB.close(); SecDB = null;
+            }
+        }
+        #endregion
+
+        #region ログイン者の参照部署を返す
+        /// <summary>
+        /// ログイン者の参照部署を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetRefDepartment(ref List<KeyValuePair<int,string>> DepList)
+        {
+            try
+            {
+                bool bRet = false;
+
+                bRet = GetRefDepartment(CommonMotions.LoginUserData.PersonCode, ref DepList);
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 対象者の参照部署を返す
+        /// <summary>
+        /// 対象者の参照部署を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetRefDepartment(int PersonCode, ref List<KeyValuePair<int, string>> DepList, bool DirectFlg = false, int SecCode = 0)
+        {
+            IOMPersonDepartment PersonDepDB = new IOMPersonDepartment();
+            try
+            {
+                DepList.Clear();
+                string strSQL = string.Empty;
+                
+                // 全部署対象の範囲コードを取得する
+                int AllPathRange = CommonDefine.SecurityRangeList[(int)CommonDefine.SecurityRangePos.AllPath].Key;
+                int TargetRank = 0;
+                int TargetRange = 0;
+                // セキュリティコード直接指定の場合
+                if (DirectFlg)
+                {
+                    TargetRank = GetDataAccessRank(SecCode, ref TargetRange);
+                }
+                else
+                {
+                    TargetRank = GetPersonDataAccessRank(PersonCode, ref TargetRange);
+                }
+
+                // 対象者のセキュリティ範囲が全部署対応ならば全部署をセットする
+                if (TargetRange == AllPathRange)
+                {
+                    strSQL = "SELECT DEPARTMENTCODE, DEPARTMENTSTRING, DISPLAYORDER";
+                    strSQL += " FROM DEPARTMENTMASTER";
+                    strSQL += " WHERE DELETEFLG = 0　ORDER BY DISPLAYORDER";
+                }
+                else
+                {
+                    // 参照部署マスタより部署を取得する
+                    strSQL = "SELECT A.DEPARTMENTCODE, B.DEPARTMENTSTRING, A.AFFILIATIONFLG, A.PERSONCODE";
+                    strSQL += " FROM PERSONDEPARTMENTMASTER A, DEPARTMENTMASTER B";
+                    strSQL += " WHERE B.DEPARTMENTCODE = A.DEPARTMENTCODE";
+                    strSQL += string.Format(" AND A.PERSONCODE = {0}", PersonCode);
+                }
+                ArrayList arList = new ArrayList();
+                if (!PersonDepDB.ExecuteReader(strSQL, ref arList)) return false;
+
+                if (arList.Count == 0) return false;
+                foreach (object[] objRec in arList)
+                {
+                    DepList.Add(new KeyValuePair<int, string>(CommonMotions.cnvInt(objRec[0]), CommonMotions.cnvString(objRec[1])));
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDepDB.close(); PersonDepDB = null;
+            }
+        }
+        #endregion
+
+        #region ログイン者の保護区分を返す
+        /// <summary>
+        /// ログイン者の保護区分を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetSecurityLevel(ref int SecCode, ref String SecName)
+        {
+            try
+            {
+                bool bRet = false;
+
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    bRet = GetSecurityLevel(CommonMotions.LoginUserData.PersonCode, ref SecCode, ref SecName);
+                }
+                else
+                {
+                    SecCode = CommonMotions.LoginUserSecurity.SecCode;
+                    SecName = CommonMotions.LoginUserSecurity.SecName;
+                    bRet = true;
+                }
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 対象者の保護区分を返す
+        /// <summary>
+        /// 対象者の保護区分を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetSecurityLevel(int PersonCode, ref int SecCode, ref String SecName)
+        {
+            IOMSecurity SecDB = new IOMSecurity();
+            try
+            {
+                // 担当者マスタより保護区分マスタを取得する
+                string strSQL = "SELECT A.PERSONCODE, A.PERSONNAME, B.SECCODE, B.SECNAME";
+                strSQL += " FROM PERSONINCHARGEMASTER A, SECURITYMASTER B";
+                strSQL += " WHERE B.SECCODE = A.SECCODE";
+                strSQL += string.Format(" AND A.PERSONCODE = {0}", PersonCode);
+
+                ArrayList arList = new ArrayList();
+                if (!SecDB.ExecuteReader(strSQL, ref arList)) return false;
+
+                if (arList.Count == 0) return false;
+                object[] objRec = (object[])arList[0];
+
+                // セキュリティ取得
+                SecCode = CommonMotions.cnvInt(objRec[2]);
+                SecName = CommonMotions.cnvString(objRec[3]);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                SecDB.close(); SecDB = null;
+            }
+        }
+        #endregion
+
+        #region ログイン者の起動権限を返す
+        /// <summary>
+        /// ログイン者の起動権限を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetExecutePermission(int ExecCode, ref int Editflg)
+        {
+            try
+            {
+                // 旧セキュリティを使用している場合はチェック無
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    Editflg = (int)CommonDefine.ProcessDataEdit.Edit;
+                    return true;
+                }
+
+                bool bRet = false;
+                if (CommonMotions.LoginUserProcExe.Count != 0)
+                {
+                    foreach (ProcessExcute CurRec in CommonMotions.LoginUserProcExe)
+                    {
+                        if (ExecCode == CurRec.ExecCode)
+                        {
+                            bRet = true;
+                            Editflg = CurRec.EditFlg;
+                            break;
+                        }
+                    }
+                }
+                else
+                {
+                    bRet = GetExecutePermission(CommonMotions.LoginUserData.PersonCode, ExecCode, ref Editflg);
+                }
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 対象者の起動権限を返す
+        /// <summary>
+        /// 対象者の起動権限を返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool GetExecutePermission(int PersonCode, int ExecCode, ref int Editflg)
+        {
+            IOMProcessExcute ExecDB = new IOMProcessExcute();
+            try
+            {
+                if (PersonCode == CommonMotions.LoginUserData.PersonCode)
+                {   // ログイン者はメモリ上よりチェックする
+                    bool bRet = false;
+                    foreach (ProcessExcute CurRec in CommonMotions.LoginUserProcExe)
+                    {
+                        if (CurRec.ExecCode == ExecCode)
+                        {
+                            bRet = true;
+                            Editflg = CurRec.EditFlg;
+                            break;
+                        }
+                    }
+                    // データが無い場合は起動無
+                    if (!bRet) return false;
+                }
+                else
+                {   // ログイン者以外はDBより読込チェックする
+                    string strSQL = "SELECT B.EXECCODE, B.EDITFLG, A.PERSONCODE, A.PERSONNAME, B.SECCODE";
+                    strSQL += " FROM PERSONINCHARGEMASTER A, PROCESSEXCUTEMASTER B";
+                    strSQL += " WHERE B.SECCODE = A.SECCODE";
+                    strSQL += string.Format(" AND A.PERSONCODE = {0}", PersonCode);
+                    strSQL += string.Format(" AND B.EXECCODE = {0}", ExecCode);
+
+                    ArrayList arList = new ArrayList();
+                    if (!ExecDB.ExecuteReader(strSQL, ref arList)) return false;
+
+                    if (arList.Count == 0) return false;
+                    object[] objRec = (object[])arList[0];
+
+                    // 編集フラグ取得
+                    Editflg = CommonMotions.cnvInt(objRec[1]);
+                }
+                // ここまで来た場合は起動OK
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ExecDB.close(); ExecDB = null;
+            }
+        }
+        #endregion
+
+        #region ログイン者が対象データにアクセスできるかを返す
+        /// <summary>
+        /// 指定対象者が対象データにアクセスできるかを返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool PersonDataAccess(int ConstructionCode, bool bWriteFlg = true)
+        {
+            try
+            {
+                bool bRet = false;
+
+                bRet = PersonDataAccess(CommonMotions.LoginUserData.PersonCode, ConstructionCode, bWriteFlg);
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 対象者が対象データにアクセスできるかを返す
+        /// <summary>
+        /// 対象者が対象データにアクセスできるかを返す
+        /// </summary>
+        /// <returns></returns>
+        public static bool PersonDataAccess(int PersonCode, int ConstructionCode, bool bWriteFlg = true)
+        {
+            try
+            {
+                // 指定対象者のセキュリティ区分・範囲を取得する
+                int Range = 0;
+                int Rank = GetPersonDataAccessRank(PersonCode, ref Range);
+                // 設定されていない場合は旧メソッドを呼ぶ
+                if (Rank == 0 && Range == 0)
+                {
+                    return ConstructionDataAccessPermission(ConstructionCode, bWriteFlg);
+                }
+
+                int SRank = (int)CommonDefine.SecurityRankPos.SpecialAuthority;     // 経営者アクセス
+                int FRank = (int)CommonDefine.SecurityRankPos.FreeAuthority;        // 統括者アクセス
+                int LRank = (int)CommonDefine.SecurityRankPos.LimitedAuthority;     // 所属長アクセス
+                int NRank = (int)CommonDefine.SecurityRankPos.NormalAuthority;      // 一般者アクセス
+
+                // 工事情報を取得する
+                int StatusCode = 0;
+                int TransferCode = 0;
+                int TransDepCode = 0;
+                List<KeyValuePair<int, int>> DataArrary = new List<KeyValuePair<int, int>>();
+                if (!GetBaseData(ConstructionCode, ref DataArrary, ref StatusCode, ref TransferCode, ref TransDepCode)) return false;
+
+                // システム管理者は全てON
+                if (CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode)
+                {
+                    return true;
+                }
+                else if (Rank == CommonDefine.SecurityRankList[SRank].Key)           // 経営者アクセス
+                {
+                    // ===== 全データ対象の場合はOK
+                    return true;
+                }
+                else if (Rank == CommonDefine.SecurityRankList[FRank].Key)           // 統括者アクセス
+                {
+                    // ===== 統括者アクセス対象の条件を調べる
+                    return LimitAccesCheck(PersonCode, DataArrary, StatusCode, TransferCode, TransDepCode);
+                }
+                else if (Rank == CommonDefine.SecurityRankList[LRank].Key)      // 所属長アクセス
+                {
+                    // ===== 所属長アクセス対象の条件を調べる
+                    return LimitAccesCheck(PersonCode, DataArrary, StatusCode, TransferCode, TransDepCode);
+                }
+                else if (Rank == CommonDefine.SecurityRankList[NRank].Key)      // 一般者アクセス
+                {
+                    // ===== 一般者アクセス対象の条件を調べる
+                    return NormalAccessCheck(PersonCode, DataArrary, StatusCode);
+                }
+
+                return false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 担当者取得情報配列行数
+        /// <summary>
+        /// 担当者情報配列行数
+        /// </summary>
+        private enum PersonArrary
+        {
+            /// <summary>
+            ///  営業担当者：部署
+            /// </summary>
+            Sales = 0,
+            /// <summary>
+            /// 工事担当者：部署
+            /// </summary>
+            Constr,
+            /// <summary>
+            /// 工事副担当：部署
+            /// </summary>
+            Assist,
+            /// <summary>
+            /// 工事指導員：部署
+            /// </summary>
+            Inst,
+        }
+        #endregion 
+
+        #region 工事情報を取得する
+        /// <summary>
+        /// 工事情報を取得する
+        /// </summary>
+        private static bool GetBaseData(int ConstructionCode, ref List<KeyValuePair<int, int>> DataArrary, ref int StatusCode, ref int TransferCode, ref int TransDepCode)
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 工事情報を取得する
+                string strBase = "SELECT A.CONSTRUCTIONCODE,";
+                strBase += " A.SALESPERSONCODE, B.DEPARTMENTCODE,";
+                strBase += " A.CONSTRUCTIONPERSONCODE, C.DEPARTMENTCODE,";
+                strBase += " D.PERSONCODE, D.DEPARTMENTCODE,";
+                strBase += " E.PERSONCODE, E.DEPARTMENTCODE,";
+                strBase += " A.CONSTRUCTIONSTATUSFLG,";
+                strBase += " A.TRANSFERCONSTRUCTION,";
+                strBase += " F.DEPARTMENTCODE";
+                strBase += " FROM CONSTRUCTIONBASEINFO A";
+                strBase += " LEFT JOIN PERSONINCHARGEMASTER B ON B.PERSONCODE = A.SALESPERSONCODE";
+                strBase += " LEFT JOIN PERSONINCHARGEMASTER C ON C.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                strBase += " LEFT JOIN PERSONINCHARGEMASTER D ON D.PERSONCODE = A.CONSTRSUBPERSONCODE";
+                strBase += " LEFT JOIN PERSONINCHARGEMASTER E ON E.PERSONCODE = A.CONSTRUCTIONINSTRUCTOR";
+                strBase += " LEFT JOIN PERSONINCHARGEMASTER F ON F.PERSONCODE = A.TRANSFERCONSTRUCTION";
+                strBase += BaseDB.CreatePrimarykeyString(ConstructionCode);
+
+                ArrayList arBaseList = new ArrayList();
+                if (!BaseDB.ExecuteReader(strBase, ref arBaseList)) return false;
+                if (arBaseList.Count == 0) return false;
+
+                object[] objBaseRec = (object[])arBaseList[0];
+
+                // ----- 取得データを配列領域へセットする
+                // 営業担当者：部署
+                // 工事担当者：部署
+                // 工事副担当：部署
+                // 工事指導員：部署
+                DataArrary.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objBaseRec[1]), CommonMotions.cnvInt(objBaseRec[2])));
+                DataArrary.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objBaseRec[3]), CommonMotions.cnvInt(objBaseRec[4])));
+                DataArrary.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objBaseRec[5]), CommonMotions.cnvInt(objBaseRec[6])));
+                DataArrary.Add(new KeyValuePair<int, int>(CommonMotions.cnvInt(objBaseRec[7]), CommonMotions.cnvInt(objBaseRec[8])));
+
+                // 工事状態を取得する
+                StatusCode = CommonMotions.cnvInt(objBaseRec[9]);
+                // 引継コードを取得する
+                TransferCode = CommonMotions.cnvInt(objBaseRec[10]);
+                // 引継部署を取得する
+                TransDepCode = CommonMotions.cnvInt(objBaseRec[11]);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region 所属長アクセスチェック
+        /// <summary>
+        /// 所属長アクセスチェック
+        /// </summary>
+        /// <returns></returns>
+        private static bool LimitAccesCheck(int PersonCode, List<KeyValuePair<int, int>> DataArrary, int StatusCode, int TransferCode, int TransDepCode)
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            IOMPersonDepartment PersonDepDB = new IOMPersonDepartment();
+            try
+            {
+                bool bAccessFlg = false;
+
+                int EstimateStatus = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("見積提出")).Key;
+                int TransferStatus = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("部署引継")).Key;
+                int ProvisionalStatus = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("仮 受 注")).Key;
+
+                // ----- 対象者のデータを取得する
+                List<PersonDepartmentMaster> TargetDepartment = new List<PersonDepartmentMaster>();
+                int DepartmentCode = 0;
+                if (PersonCode == CommonMotions.LoginUserData.PersonCode)
+                {   
+                    // ----- ログイン者はメモリより取得
+                    DepartmentCode = CommonMotions.LoginUserData.DepartmentCode;
+                    foreach (PersonDepartmentMaster wrkRec in CommonMotions.LoginUserDepartment)
+                    {
+                        TargetDepartment.Add(wrkRec);
+                    }
+                }
+                else
+                {   
+                    // ----- 以外はDBより取得する
+                    // 担当者マスタ取得
+                    string strPerson = PersonDB.CreatePrimarykeyString(PersonCode);
+                    PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                    PersonDB.SelectAction(strPerson, ref PersonRec);
+                    DepartmentCode = PersonRec.DepartmentCode;
+                    // 担当者参照部署マスタ取得
+                    PersonDepDB.SelectAction(strPerson, ref TargetDepartment);
+                }
+
+                // ------ 状態判定
+                // 部署引継の場合、引継部署・引継担当者部署を検索対象にする
+                if (TransferStatus == StatusCode)
+                {
+                    int RefDepCode = 0;
+                    if (TransferCode <= 99999)
+                    {
+                        RefDepCode = TransferCode;
+                    }
+                    else
+                    {
+                        RefDepCode = TransDepCode;
+                    }
+                    foreach (PersonDepartmentMaster wrkRec in TargetDepartment)
+                    {
+                        if (RefDepCode == wrkRec.DepartmentCode)
+                        {
+                            bAccessFlg = true;
+                            break;
+                        }
+                    }
+                }
+                else if (EstimateStatus <= StatusCode)
+                {   // 見積提出後は参照可能部署ならば常に見ることができる
+                    for (int i = 0; i < DataArrary.Count; i++)
+                    {
+                        foreach (PersonDepartmentMaster wrkRec in TargetDepartment)
+                        {
+                            if (DataArrary[i].Value == wrkRec.DepartmentCode)
+                            {
+                                bAccessFlg = true;
+                                break;
+                            }
+                        }
+                        if (bAccessFlg) break;
+                    }
+                }
+                else
+                {
+                    // 以外の場合は参照部署のみ
+                    for (int i = 0; i < DataArrary.Count; i++)
+                    {
+                        foreach (PersonDepartmentMaster wrkRec in TargetDepartment)
+                        {
+
+                            if (DataArrary[i].Value == wrkRec.DepartmentCode)
+                            {
+                                switch (i)
+                                {
+                                    case (int)PersonArrary.Sales:
+                                        // 営業担当者
+                                        bAccessFlg = true;
+                                        break;
+                                    case (int)PersonArrary.Constr:
+                                        // 仮受注以降でないとアクセス出来ない
+                                        if (StatusCode < ProvisionalStatus) continue;
+
+                                        // 工事担当者
+                                        bAccessFlg = true;
+                                        break;
+                                    case (int)PersonArrary.Assist:
+                                        // 仮受注以降でないとアクセス出来ない
+                                        if (StatusCode < ProvisionalStatus) continue;
+
+                                        // 工事副担当者
+                                        bAccessFlg = true;
+                                        break;
+                                    case (int)PersonArrary.Inst:
+                                        // 仮受注以降でないとアクセス出来ない
+                                        if (StatusCode < ProvisionalStatus) continue;
+
+                                        // 工事指導員
+                                        bAccessFlg = true;
+                                        break;
+                                }
+                            }
+                            if (bAccessFlg) break;
+                        }
+                        if (bAccessFlg) break;
+                    }
+                }
+
+                return bAccessFlg;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+                PersonDepDB.close(); PersonDepDB = null;
+            }
+        }
+        #endregion
+
+        #region 一般者アクセスチェック
+        /// <summary>
+        /// 一般者アクセスチェック
+        /// </summary>
+        /// <returns></returns>
+        private static bool NormalAccessCheck(int PersonCode, List<KeyValuePair<int, int>> DataArrary, int StatusCode)
+        {
+            try
+            {
+                bool bAccessFlg = false;
+
+                // 全てアクセスできる工事状態は以下の状態以外
+                int AccessStatus = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("見積提出")).Key;
+
+                // 担当者コードをチェックする
+                for (int i = 0; i < DataArrary.Count; i++)
+                {
+                    if (DataArrary[i].Key == PersonCode)
+                    {
+                        if (i != (int)PersonArrary.Sales)
+                        {
+                            // 営業担当者以外は仮受注以降でないとアクセス出来ない
+                            if (StatusCode <= AccessStatus) continue;
+                        }
+                        bAccessFlg = true;
+                        break;
+                    }
+                }
+
+                return bAccessFlg;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #endregion
     }
 }
